// #autoload
// #name = MapFavorites
// #description = Gives you 20 favorites for each map.
// #author = ilys
// #warrior = ilys
// #category = ilys' Scripts
// #include = support/callback.cs
// #include = support/mission_callbacks.cs

package MapFavorites {
function PlayGui::onWake(%this)
{
	Callback.add(onGameOver, "ResetMapFavorites");
	Callback.add(onUserClientDrop, "ResetMapFavorites");
	parent::onWake(%this);
	if($FavesNotLoaded) schedule(2500, 0, SetFaves);
}
function SetFaves()
{
	$MapName = MissionCallback.getMissionName();
	if(!isFile("prefs/loadouts/"@$MapName@".fav"))
	{
		for(%i = 0; %i < 20; %i++)
		{
			$Faves::FavNames[%i] = $pref::FavNames[%i];
			$Faves::Favorite[%i] = $pref::Favorite[%i];
		}
		export("$Faves::*", "prefs/loadouts/"@$Mapname@".fav", False);
	}
	exec("prefs/loadouts/"@$MapName@".fav");
	%temp = $pref::FavCurrentSelect;
	for(%i = 0; %i < 20; %i++)
	{
		$pref::FavNames[%i] = $Faves::FavNames[%i];
		$pref::Favorite[%i] = $Faves::Favorite[%i];
		loadFavorite(%i, 0);
	}
	$pref::FavCurrentSelect = %temp;
	loadFavorite(%temp, 0);
	$FavesNotLoaded = 0;
}
function InventoryScreen::setupHud( %this, %tag )
{
	parent::setupHud( %this, %tag );
	$Hud[%tag].staticData[1, 0].command = "saveMapFavorite();";
	$Hud[%tag].staticData[1, 1].altCommand = "saveMapFavorite();";
}
};
activatepackage(MapFavorites);
function saveMapFavorite()
{
	if($pref::FavCurrentSelect !$= "")
	{
		%favName = $Hud['inventoryScreen'].staticData[1, 1].getValue();
		$pref::FavNames[$pref::FavCurrentSelect] = %favName;
		$Hud['inventoryScreen'].staticData[0, $pref::FavCurrentSelect - ($pref::FavCurrentList * 10) + 1].setText( strupr( %favName ) );
		%favList = $Hud['inventoryScreen'].data[0, 1].type TAB $Hud['inventoryScreen'].data[0, 1].getValue();
		for ( %i = 1; %i < $Hud['inventoryScreen'].count; %i++ )
		{
			%name = $Hud['inventoryScreen'].data[%i, 1].getValue();
			if(%name $= invalid) %name = "EMPTY";
			%favList = %favList TAB $Hud['inventoryScreen'].data[%i, 1].type TAB %name;
		}
		$pref::Favorite[$pref::FavCurrentSelect] = %favList;
		export("$pref::*", "prefs/ClientPrefs.cs", False);
		$Faves::FavNames[$pref::FavCurrentSelect] = %favName;
		$Faves::Favorite[$pref::FavCurrentSelect] = %favList;
		export("$Faves::*", "prefs/loadouts/"@$Mapname@".fav", False);
	}
}
function ResetMapFavorites()
{
	$FavesNotLoaded = 1;
}
$FavesNotLoaded = 1;
